Index: trunk/kernel/kern/process.c
===================================================================
--- trunk/kernel/kern/process.c	(revision 690)
+++ trunk/kernel/kern/process.c	(revision 1)
@@ -510,491 +204,127 @@
     cluster_process_copies_link( local_process );
 
-	hal_fence();
-
-#if DEBUG_PROCESS_COPY_INIT 
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_COPY_INIT < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, local_process->pid, cycle );
-#endif
+	hal_wbflush();
 
     return 0;
 
-} // end process_copy_init()
+}  // end process_copy_init()
 
 ///////////////////////////////////////////
 void process_destroy( process_t * process )
 {
-    xptr_t      parent_xp;
-    process_t * parent_ptr;
-    cxy_t       parent_cxy;
-    xptr_t      children_lock_xp;
-    xptr_t      children_nr_xp;
-
-    pid_t       pid = process->pid;
-
-// check no more threads
-assert( __FUNCTION__, (process->th_nr == 0),
-"process %x in cluster %x contains threads", pid , local_cxy );
-
-#if DEBUG_PROCESS_DESTROY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] enter for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy, cycle );
-#endif
+	if( process->th_nr != 0 )  
+    {
+	    printk("\n[PANIC] in %s : process %x in cluster %x has still active threads\n",
+               __FUNCTION__ , process->pid , local_cxy );
+        hal_core_sleep();
+    }
+
+    // get local process manager pointer
+    pmgr_t * pmgr = &LOCAL_CLUSTER->pmgr;
+
+    // remove the process descriptor from local_list in local cluster manager 
+    spinlock_lock( &pmgr->local_lock );
+    xlist_unlink( XPTR( local_cxy , &process->local_list ) );
+    spinlock_unlock( &pmgr->local_lock );
+
+    // get extended pointer on copies_lock in owner cluster manager
+    cxy_t  owner_cxy    = CXY_FROM_PID( process->pid );
+	lpid_t lpid         = LPID_FROM_PID( process->pid );
+    xptr_t copies_lock  = hal_remote_lwd( XPTR( owner_cxy , &pmgr->copies_lock[lpid] ) );
+
+    // remove the local process descriptor from copies_list
+    remote_spinlock_lock( copies_lock );
+    xlist_unlink( XPTR( local_cxy , &process->copies_list ) );
+    remote_spinlock_unlock( copies_lock );
+    
+    // synchronize memory
+	hal_wbflush();
+
+    // From this point, the process descriptor is unreachable 
+
+    // release signal manager TODO [AG]
+
+    // delete all open file descriptors
+    process_fd_destroy( process );
+
+    // Close bin file and decrease refcount for root and cwd
+	if( process->vfs_bin_xp != XPTR_NULL ) vfs_close( process->vfs_bin_xp , NULL );
+    vfs_file_count_down( process->vfs_root_xp );
+    vfs_file_count_down( process->vfs_cwd_xp );
 
     // Destroy VMM
     vmm_destroy( process );
 
-#if (DEBUG_PROCESS_DESTROY & 1)
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] destroyed VMM for process %x in cluster %x\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy );
-#endif
-
-    // remove process from local_list in local cluster manager
-    cluster_process_local_unlink( process );
-
-#if (DEBUG_PROCESS_DESTROY & 1)
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] removed process %x in cluster %x from local list\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy );
-#endif
-
-    // remove process from copies_list in owner cluster manager
-    cluster_process_copies_unlink( process );
-
-#if (DEBUG_PROCESS_DESTROY & 1)
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] removed process %x in cluster %x from copies list\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy );
-#endif
-
-    // when target process cluster is the owner cluster
-    // - remove process from TXT list and transfer ownership
-    // - remove process from children_list 
-    // - release PID
-    if( CXY_FROM_PID( pid ) == local_cxy )
-    {
-        process_txt_detach( XPTR( local_cxy , process ) );
-
-#if (DEBUG_PROCESS_DESTROY & 1)
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] removed process %x from TXT list\n",
-__FUNCTION__, this->process->pid, this->trdid, pid );
-#endif
-
-        // get pointers on parent process
-        parent_xp  = process->parent_xp;
-        parent_cxy = GET_CXY( parent_xp );
-        parent_ptr = GET_PTR( parent_xp );
-
-        // get extended pointer on children_lock in parent process
-        children_lock_xp = XPTR( parent_cxy , &parent_ptr->children_lock );
-        children_nr_xp   = XPTR( parent_cxy , &parent_ptr->children_nr );
-
-        // remove process from children_list
-        remote_queuelock_acquire( children_lock_xp );
-        xlist_unlink( XPTR( local_cxy , &process->children_list ) );
-	    hal_remote_atomic_add( children_nr_xp , -1 );
-        remote_queuelock_release( children_lock_xp );
-
-#if (DEBUG_PROCESS_DESTROY & 1)
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] removed process %x from parent process children list\n",
-__FUNCTION__, this->process->pid, this->trdid, pid );
-#endif
-
-        // release the process PID to cluster manager
-        cluster_pid_release( pid );
-
-#if (DEBUG_PROCESS_DESTROY & 1)
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] released process PID %x to pmgr in cluster %x\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy );
-#endif
-
-    }
-
-    // FIXME decrement the refcount on file pointer for vfs_bin_xp [AG]
-
-    // FIXME close all open files [AG]
-
-    // FIXME synchronize dirty files [AG]
-
-    // release memory allocated to process descriptor
-	kmem_free( process , bits_log2(sizeof(process_t)) );
-
-#if DEBUG_PROCESS_DESTROY
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy, cycle );
-#endif
+	process_dmsg("\n[INFO] %s for pid %d / page_faults = %d\n",
+	         __FUNCTION__ , process->pid, process->vmm.pgfault_nr );
 
 }  // end process_destroy()
 
-///////////////////////////////////////////////////////////////////
-const char * process_action_str( process_sigactions_t action_type )
-{
-    switch ( action_type )
-    {
-        case BLOCK_ALL_THREADS:   return "BLOCK";
-        case UNBLOCK_ALL_THREADS: return "UNBLOCK";
-        case DELETE_ALL_THREADS:  return "DELETE";
-        default:                  return "undefined";
-    }
-}
-
 ////////////////////////////////////////
-void process_sigaction( pid_t       pid,
-                        uint32_t    type )
-{
-    cxy_t              owner_cxy;         // owner cluster identifier
-    lpid_t             lpid;              // process index in owner cluster
-    cluster_t        * cluster;           // pointer on cluster manager
-    xptr_t             root_xp;           // extended pointer on root of copies
-    xptr_t             lock_xp;           // extended pointer on lock protecting copies
-    xptr_t             iter_xp;           // iterator on copies list
-    xptr_t             process_xp;        // extended pointer on process copy
-    cxy_t              process_cxy;       // process copy cluster identifier
-    process_t        * process_ptr;       // local pointer on process copy
-    reg_t              save_sr;           // for critical section
-    thread_t         * client;            // pointer on client thread
-    xptr_t             client_xp;         // extended pointer on client thread
-    process_t        * local;             // pointer on process copy in local cluster
-    uint32_t           remote_nr;         // number of remote process copies
-    rpc_desc_t         rpc;               // shared RPC descriptor
-    uint32_t           responses;         // shared RPC responses counter
-
-    client    = CURRENT_THREAD;
-    client_xp = XPTR( local_cxy , client );
-    local     = NULL;
-    remote_nr = 0;
-
-    // check calling thread can yield
-    thread_assert_can_yield( client , __FUNCTION__ );
-
-#if DEBUG_PROCESS_SIGACTION
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] enter to %s process %x / cycle %d\n",
-__FUNCTION__ , client->process->pid, client->trdid,
-process_action_str( type ) , pid , cycle );
-#endif
-
-    // get pointer on local cluster manager
-    cluster = LOCAL_CLUSTER;
-
-    // get owner cluster identifier and process lpid
-    owner_cxy = CXY_FROM_PID( pid );
-    lpid      = LPID_FROM_PID( pid );
-
-    // get root of list of copies and lock from owner cluster
-    root_xp   = XPTR( owner_cxy , &cluster->pmgr.copies_root[lpid] );
-    lock_xp   = XPTR( owner_cxy , &cluster->pmgr.copies_lock[lpid] );
-
-// check action type
-assert( __FUNCTION__, ((type == DELETE_ALL_THREADS ) ||
-         (type == BLOCK_ALL_THREADS )  ||
-         (type == UNBLOCK_ALL_THREADS )), "illegal action type" );
-             
-    // This client thread send parallel RPCs to all remote clusters containing
-    // target process copies, wait all responses, and then handles directly 
-    // the threads in local cluster, when required.
-    // The client thread allocates a - shared - RPC descriptor in the stack,
-    // because all parallel, non-blocking, server threads use the same input 
-    // arguments, and use the shared RPC response field
-
-    // mask IRQs
-    hal_disable_irq( &save_sr);
-
-    // client thread blocks itself
-    thread_block( client_xp , THREAD_BLOCKED_RPC );
-
-    // initialize RPC responses counter
-    responses = 0;
-
-    // initialize shared RPC descriptor
-    // can be shared, because no out arguments
-    rpc.rsp       = &responses;
-    rpc.blocking  = false;
-    rpc.index     = RPC_PROCESS_SIGACTION;
-    rpc.thread    = client;
-    rpc.lid       = client->core->lid;
-    rpc.args[0]   = pid;
-    rpc.args[1]   = type;
-
-    // take the lock protecting process copies
-    remote_queuelock_acquire( lock_xp );
-
-    // scan list of process copies
-    XLIST_FOREACH( root_xp , iter_xp )
-    {
-        // get extended pointers and cluster on process
-        process_xp  = XLIST_ELEMENT( iter_xp , process_t , copies_list );
-        process_cxy = GET_CXY( process_xp );
-        process_ptr = GET_PTR( process_xp );
-
-        if( process_cxy == local_cxy )    // process copy is local
-        { 
-            local = process_ptr;
+void process_kill( process_t * process )
+{
+    thread_t     * thread;    // pointer on current thead descriptor
+    uint32_t       ltid;      // index in process th_tbl
+    uint32_t       count;     // thread counter
+
+    // get lock protecting th_tbl[]
+    spinlock_lock( &process->th_lock );
+
+    // first loop on threads to send the THREAD_SIG_KILL signal to all peocess threads
+    // we use both "ltid" and "count" indexes, because it can exist "holes" in th_tbl
+    for( ltid = 0 , count = 0  ; 
+         (ltid < CONFIG_THREAD_MAX_PER_CLUSTER) && (count < process->th_nr) ; 
+         ltid++ )
+    {
+        thread = process->th_tbl[ltid];
+
+        if( thread != NULL )
+        {
+            thread_kill( thread );
+            count++;
         }
-        else                              // process copy is remote
+    }   
+    
+    volatile uint32_t ko;
+
+    // second loop on threads to wait acknowledge from scheduler,
+    // unlink thread from process and parent thread, and release thread descriptor
+    for( ltid = 0 , count = 0  ; 
+         (ltid < CONFIG_THREAD_MAX_PER_CLUSTER) && (count < process->th_nr) ;
+         ltid++ )
+    {
+        thread = process->th_tbl[ltid];
+
+        if( thread != NULL )
         {
-            // update number of remote process copies
-            remote_nr++;
-
-            // atomically increment RPC responses counter
-            hal_atomic_add( &responses , 1 );
-
-#if DEBUG_PROCESS_SIGACTION 
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] send RPC to cluster %x for process %x\n",
-__FUNCTION__, client->process->pid, client->trdid, process_cxy, pid );
-#endif
-            // call RPC in target cluster
-            rpc_send( process_cxy , &rpc );
+            // wait scheduler acknowledge
+            do { ko = (thread->signals & THREAD_SIG_KILL); } while( ko );
+
+            // unlink thread from brothers list if required
+            if( (thread->flags & THREAD_FLAG_DETACHED) == 0 ) 
+            xlist_unlink( XPTR( local_cxy , &thread->brothers_list ) );
+
+            // unlink thread from process
+            process_remove_thread( thread );
+
+            // release memory for thread descriptor
+            thread_destroy( thread );
+
+            count++;
         }
-    }  // end list of copies
-
-    // release the lock protecting process copies
-    remote_queuelock_release( lock_xp );
-
-    // restore IRQs
-    hal_restore_irq( save_sr);
-
-    // - if there is remote process copies, the client thread deschedules,
-    //   (it will be unblocked by the last RPC server thread). 
-    // - if there is no remote copies, the client thread unblock itself.
-    if( remote_nr )
-    {
-        sched_yield("blocked on rpc_process_sigaction");
-    } 
-    else
-    {
-        thread_unblock( client_xp , THREAD_BLOCKED_RPC );
-    }
-
-    // handle the local process copy if required
-    if( local != NULL )
-    {
-
-#if DEBUG_PROCESS_SIGACTION 
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] handles local process %x in cluster %x\n",
-__FUNCTION__, client->process->pid, client->trdid, pid , local_cxy );
-#endif
-        if     (type == DELETE_ALL_THREADS  ) process_delete_threads ( local , client_xp ); 
-        else if(type == BLOCK_ALL_THREADS   ) process_block_threads  ( local ); 
-        else if(type == UNBLOCK_ALL_THREADS ) process_unblock_threads( local );
-    }
-
-#if DEBUG_PROCESS_SIGACTION
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] exit after %s process %x / cycle %d\n",
-__FUNCTION__, client->process->pid, client->trdid,
-process_action_str( type ), pid, cycle );
-#endif
-
-}  // end process_sigaction()
-
-/////////////////////////////////////////////////
-void process_block_threads( process_t * process )
-{
-    thread_t          * target;         // pointer on target thread 
-    thread_t          * this;           // pointer on calling thread 
-    uint32_t            ltid;           // index in process th_tbl[]
-    uint32_t            count;          // requests counter
-    volatile uint32_t   ack_count;      // acknowledges counter
-
-    // get calling thread pointer
-    this = CURRENT_THREAD;
-
-#if DEBUG_PROCESS_SIGACTION
-pid_t pid = process->pid;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] enter for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy , cycle );
-#endif
-
-// check target process is an user process
-assert( __FUNCTION__, (LPID_FROM_PID( process->pid ) != 0 ),
-"process %x is not an user process\n", process->pid );
-
-    // get lock protecting process th_tbl[]
-    rwlock_rd_acquire( &process->th_lock );
-
-    // loop on target process local threads 
-    // we use both "ltid" and "count" because it can exist "holes" in th_tbl
-    // - if the calling thread and the target thread are not running on the same
-    //   core, we ask the target scheduler to acknowlege the blocking
-    //   to be sure that the target thread is not running.
-    // - if the calling thread and the target thread are running on the same core,
-    //   we don't need confirmation from scheduler.
-            
-    for( ltid = 0 , count = 0 , ack_count = 0 ; count < process->th_nr ; ltid++ )
-    {
-        target = process->th_tbl[ltid];
-
-        if( target != NULL )                                 // thread exist
-        {
-            count++;
-
-            // set the global blocked bit in target thread descriptor.
-            thread_block( XPTR( local_cxy , target ) , THREAD_BLOCKED_GLOBAL );
-  
-            if( this->core->lid != target->core->lid )
-            {
-                // increment responses counter 
-                hal_atomic_add( (void*)&ack_count , 1 );
-
-                // set FLAG_REQ_ACK and &ack_rsp_count in target descriptor
-                thread_set_req_ack( target , (uint32_t *)&ack_count );
-
-                // force scheduling on target thread
-                dev_pic_send_ipi( local_cxy , target->core->lid );
-            }
-        }
-    }
-
-    // release lock protecting process th_tbl[]
-    rwlock_rd_release( &process->th_lock );
-
-    // wait other threads acknowledges  TODO this could be improved...
-    while( 1 )
-    {
-        // exit when all scheduler acknowledges received
-        if ( ack_count == 0 ) break;
-    
-        // wait 1000 cycles before retry
-        hal_fixed_delay( 1000 );
-    }
-
-#if DEBUG_PROCESS_SIGACTION
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy , cycle );
-#endif
-
-}  // end process_block_threads()
-
-/////////////////////////////////////////////////
-void process_delete_threads( process_t * process,
-                             xptr_t      client_xp )
-{
-    thread_t          * target;        // local pointer on target thread 
-    xptr_t              target_xp;     // extended pointer on target thread
-    cxy_t               owner_cxy;     // owner process cluster
-    uint32_t            ltid;          // index in process th_tbl
-    uint32_t            count;         // threads counter
-
-    // get calling thread pointer
-
-    // get target process owner cluster
-    owner_cxy = CXY_FROM_PID( process->pid );
-
-#if DEBUG_PROCESS_SIGACTION
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] enter for process %x n cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, process->pid, local_cxy, cycle );
-#endif
-
-// check target process is an user process
-assert( __FUNCTION__, (LPID_FROM_PID( process->pid ) != 0),
-"process %x is not an user process\n", process->pid );
-
-    // get lock protecting process th_tbl[]
-    rwlock_wr_acquire( &process->th_lock );
-
-    // loop on target process local threads                       
-    // we use both "ltid" and "count" because it can exist "holes" in th_tbl
-    for( ltid = 0 , count = 0  ; count < process->th_nr ; ltid++ )
-    {
-        target = process->th_tbl[ltid];
-
-        if( target != NULL )    // valid thread  
-        {
-            count++;
-            target_xp = XPTR( local_cxy , target );
-
-            // main thread and client thread should not be deleted
-            if( ((ltid != 0) || (owner_cxy != local_cxy)) &&         // not main thread
-                (client_xp) != target_xp )                           // not client thread
-            {
-                // mark target thread for delete and block it
-                thread_delete_request( target_xp , true );                   // forced 
-            }
-        }
-    }
-
-    // release lock protecting process th_tbl[]
-    rwlock_wr_release( &process->th_lock );
-
-#if DEBUG_PROCESS_SIGACTION
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, process->pid, local_cxy , cycle );
-#endif
-
-}  // end process_delete_threads()
-
-///////////////////////////////////////////////////
-void process_unblock_threads( process_t * process )
-{
-    thread_t          * target;        // pointer on target thead 
-    uint32_t            ltid;          // index in process th_tbl
-    uint32_t            count;         // requests counter
-
-#if DEBUG_PROCESS_SIGACTION
-thread_t * this  = CURRENT_THREAD;
-pid_t      pid   = process->pid;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] enter for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy , cycle );
-#endif
-
-// check target process is an user process
-assert( __FUNCTION__, ( LPID_FROM_PID( process->pid ) != 0 ),
-"process %x is not an user process\n", process->pid );
-
-    // get lock protecting process th_tbl[]
-    rwlock_rd_acquire( &process->th_lock );
-
-    // loop on process threads to unblock all threads
-    // we use both "ltid" and "count" because it can exist "holes" in th_tbl
-    for( ltid = 0 , count = 0 ; count < process->th_nr ; ltid++ )
-    {
-        target = process->th_tbl[ltid];
-
-        if( target != NULL )             // thread found
-        {
-            count++;
-
-            // reset the global blocked bit in target thread descriptor.
-            thread_unblock( XPTR( local_cxy , target ) , THREAD_BLOCKED_GLOBAL );
-        }
-    }
-
-    // release lock protecting process th_tbl[]
-    rwlock_rd_release( &process->th_lock );
-
-#if DEBUG_PROCESS_SIGACTION
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_SIGACTION < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy, cycle );
-#endif
-
-}  // end process_unblock_threads()
+    }
+
+    // release lock protecting th_tbl[]
+    spinlock_unlock( &process->th_lock );
+
+    // release memory allocated for process descriptor
+    process_destroy( process );
+
+}  // end process_kill()
+
+
+
+
+
 
 ///////////////////////////////////////////////
@@ -1002,30 +332,18 @@
 {
     error_t        error;
-    process_t    * process;       // local pointer on process
-    xptr_t         process_xp;    // extended pointer on process
-
-#if DEBUG_PROCESS_GET_LOCAL_COPY || DEBUG_PROCESS_ERROR
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-#endif
+    bool_t         found;
+    list_entry_t * iter;
+    process_t    * process;     // pointer on local copy
 
     cluster_t * cluster = LOCAL_CLUSTER;
 
-#if DEBUG_PROCESS_GET_LOCAL_COPY
-if( DEBUG_PROCESS_GET_LOCAL_COPY < cycle )
-printk("\n[%s] thread[%x,%x] enter for process %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, local_cxy, cycle );
-#endif
-
     // get lock protecting local list of processes
-    remote_queuelock_acquire( XPTR( local_cxy , &cluster->pmgr.local_lock ) );
+    spinlock_lock( &cluster->pmgr.local_lock );
 
     // scan the local list of process descriptors to find the process
-    xptr_t  iter;
-    bool_t  found = false;
-    XLIST_FOREACH( XPTR( local_cxy , &cluster->pmgr.local_root ) , iter )
-    {
-        process_xp  = XLIST_ELEMENT( iter , process_t , local_list );
-        process     = GET_PTR( process_xp );
+    found = false;
+    LIST_FOREACH( &cluster->pmgr.local_root , iter )
+    {
+        process = LIST_ELEMENT( iter , process_t , local_list );
         if( process->pid == pid )
         {
@@ -1036,65 +354,28 @@
 
     // release lock protecting local list of processes
-    remote_queuelock_release( XPTR( local_cxy , &cluster->pmgr.local_lock ) );
-
-    // allocate memory for a new local process descriptor
-    // and initialise it from reference cluster if not found
+    spinlock_unlock( &cluster->pmgr.local_lock );
+
+    // allocate memory for a local process descriptor 
+    // and initialise it from reference if required
     if( !found )
     {
         // get extended pointer on reference process descriptor
-        xptr_t ref_xp = cluster_get_reference_process_from_pid( pid );
-
-        assert( __FUNCTION__, (ref_xp != XPTR_NULL) , "illegal pid\n" );
+        xptr_t reference = cluster_get_reference_process_from_pid( pid );
 
         // allocate memory for local process descriptor
-        process = kmem_alloc( bits_log2(sizeof(process_t)) , AF_ZERO );
-
+        process = process_alloc();
         if( process == NULL )  return NULL;
 
         // initialize local process descriptor copy
-        error = process_copy_init( process , ref_xp );
-
-        if( error )
-        {
-
-#if DEBUG_PROCESS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot initialize local process copy / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-            return NULL;
-        }
-    }
-
-#if DEBUG_PROCESS_GET_LOCAL_COPY
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_GET_LOCAL_COPY < cycle )
-printk("\n[%s] thread[%x,%x] exit in cluster %x / process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, local_cxy, process, cycle );
-#endif
+        error = process_copy_init( process, reference );
+        if( error ) return NULL;
+
+        
+        // register process in global copies_list
+    }
 
     return process;
-
-}  // end process_get_local_copy()
-
-////////////////////////////////////////////
-pid_t process_get_ppid( xptr_t  process_xp )
-{
-    cxy_t       process_cxy;
-    process_t * process_ptr;
-    xptr_t      parent_xp;
-    cxy_t       parent_cxy;
-    process_t * parent_ptr;
-
-    // get process cluster and local pointer
-    process_cxy = GET_CXY( process_xp );
-    process_ptr = GET_PTR( process_xp );
-
-    // get pointers on parent process
-    parent_xp  = (xptr_t)hal_remote_l64( XPTR( process_cxy , &process_ptr->parent_xp ) );
-    parent_cxy = GET_CXY( parent_xp );
-    parent_ptr = GET_PTR( parent_xp );
-
-    return hal_remote_l32( XPTR( parent_cxy , &parent_ptr->pid ) );
-}
+} // end process_get_local_copy()
+
 
 //////////////////////////////////////////////////////////////////////////////////////////
